/* rbcrack.c - a Ruby interface to CrackLib
 * 
 * $Id: rbcrack.c,v 1.3 2002/09/18 07:45:57 ianmacd Exp $
 *
 */

#include "ruby.h"
#include "crack.h"
#include "rbcrack.h"

#define CRACK_VERSION "0.2.0"

VALUE eCrack_WeakPassword;

/* Crack.initialize */
static VALUE passwd_init(VALUE self, VALUE passwd)
{

  /* call superclass's initialize method */
  rb_call_super(1, &passwd);

  return passwd;
}

/* Crack.check */
static VALUE passwd_check(VALUE self, VALUE args)
{
  VALUE dict;
  char *objection;

  /* pop the one and only argument we may have been passed */
  dict = rb_ary_pop(args);

  if (dict == Qnil)
    /* no argument passed, so use default location from rbcrack.h */
    dict = rb_str_new2(CRACK_DICT);

  /* perform check on password */
  objection = FascistCheck(STR2CSTR(self), STR2CSTR(dict));

  /* return true on success; raise an exception otherwise */
  if (objection) {
    rb_raise(eCrack_WeakPassword, "%s", objection);
  } else {
    return Qtrue;
  }

}

/* initialize this class */
void Init_crack()
{
  VALUE cCrack;

  /* define the Crack class */
  cCrack = rb_define_class("Crack", rb_cString);

  /* define the Crack::WeakPassword exception */
  eCrack_WeakPassword = rb_define_class_under(cCrack, "WeakPassword",
		                              rb_eRuntimeError);

  /* define a version constant */
  rb_define_const(cCrack, "VERSION", rb_str_new2(CRACK_VERSION));

  /* define the Crack.initialize method */
  rb_define_method(cCrack, "initialize", passwd_init, 1);

  /* enable the same method in the superclass */
  rb_enable_super(cCrack, "initialize");

  /* define the Crack.check method */
  rb_define_method(cCrack, "check", passwd_check, -2);

  return;
}
